/**********************************************************************************************************************
This file is part of the Control Toolbox (https://adrlab.bitbucket.io/ct), copyright by ETH Zurich, Google Inc.
Authors:  Michael Neunert, Markus Giftthaler, Markus Stäuble, Diego Pardo, Farbod Farshidian
Licensed under Apache2 license (see LICENSE file in main directory)
**********************************************************************************************************************/

#ifndef INCLUDE_CT_RBD_RBD_H_
#define INCLUDE_CT_RBD_RBD_H_

#include <ct/optcon/optcon.h>

// declarations
#include "Internal"
#include "Common"
#include "State"
#include "Robot"
#include "Systems"
#include "Nloc"

// implementations
#include "Internal-impl"
#include "Common-impl"
#include "State-impl"
#include "Robot-impl"
#include "Systems-impl"
#include "Nloc-impl"

// keep standard header guard (easy debugging)
// header guard is identical to the one in rbd-prespec.h
#endif /* INCLUDE_CT_RBD_RBD_H_ */
